package com.ruoyi.oa.service;

import com.ruoyi.oa.domain.vo.ProjectAttendanceVo;
import com.ruoyi.oa.domain.vo.OaAttendanceRecordVo;
import com.ruoyi.oa.domain.bo.OaAttendanceRecordBo;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;

import java.util.Collection;
import java.util.List;

/**
 * 计算记录Service接口
 *
 * @author ruoyi
 * @date 2025-05-15
 */
public interface IOaAttendanceRecordService {

    /**
     * 查询计算记录
     */
    OaAttendanceRecordVo queryById(Long recordId);

    /**
     * 查询计算记录列表
     */
    TableDataInfo<OaAttendanceRecordVo> queryPageList(OaAttendanceRecordBo bo, PageQuery pageQuery);

    /**
     * 查询计算记录列表
     */
    List<OaAttendanceRecordVo> queryList(OaAttendanceRecordBo bo);

    /**
     * 新增计算记录
     */
    Boolean insertByBo(OaAttendanceRecordBo bo);

    /**
     * 修改计算记录
     */
    Boolean updateByBo(OaAttendanceRecordBo bo);

    /**
     * 校验并批量删除计算记录信息
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 获取某月的所有数据报告的生成日期
     * @param date
     * @return
     */
    List<String> listGenDate(String date);

    List<ProjectAttendanceVo> getAttendance(List<Long> userIds,String calcTime, String relationMonth);

}
